/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __UPROBE_SYSCALL_SKEL_H__
#define __UPROBE_SYSCALL_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

#define BPF_SKEL_SUPPORTS_MAP_AUTO_ATTACH 1

struct uprobe_syscall {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *bss;
	} maps;
	struct {
		struct bpf_program *uretprobe;
	} progs;
	struct {
		struct bpf_link *uretprobe;
	} links;
	struct uprobe_syscall__bss {
		struct pt_regs regs;
	} *bss;

#ifdef __cplusplus
	static inline struct uprobe_syscall *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct uprobe_syscall *open_and_load();
	static inline int load(struct uprobe_syscall *skel);
	static inline int attach(struct uprobe_syscall *skel);
	static inline void detach(struct uprobe_syscall *skel);
	static inline void destroy(struct uprobe_syscall *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
uprobe_syscall__destroy(struct uprobe_syscall *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
uprobe_syscall__create_skeleton(struct uprobe_syscall *obj);

static inline struct uprobe_syscall *
uprobe_syscall__open_opts(const struct bpf_object_open_opts *opts)
{
	struct uprobe_syscall *obj;
	int err;

	obj = (struct uprobe_syscall *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = uprobe_syscall__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	uprobe_syscall__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct uprobe_syscall *
uprobe_syscall__open(void)
{
	return uprobe_syscall__open_opts(NULL);
}

static inline int
uprobe_syscall__load(struct uprobe_syscall *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct uprobe_syscall *
uprobe_syscall__open_and_load(void)
{
	struct uprobe_syscall *obj;
	int err;

	obj = uprobe_syscall__open();
	if (!obj)
		return NULL;
	err = uprobe_syscall__load(obj);
	if (err) {
		uprobe_syscall__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
uprobe_syscall__attach(struct uprobe_syscall *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
uprobe_syscall__detach(struct uprobe_syscall *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *uprobe_syscall__elf_bytes(size_t *sz);

static inline int
uprobe_syscall__create_skeleton(struct uprobe_syscall *obj)
{
	struct bpf_object_skeleton *s;
	struct bpf_map_skeleton *map __attribute__((unused));
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "uprobe_syscall";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 1;
	s->map_skel_sz = 24;
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt,
			sizeof(*s->maps) > 24 ? sizeof(*s->maps) : 24);
	if (!s->maps) {
		err = -ENOMEM;
		goto err;
	}

	map = (struct bpf_map_skeleton *)((char *)s->maps + 0 * s->map_skel_sz);
	map->name = "uprobe_s.bss";
	map->map = &obj->maps.bss;
	map->mmaped = (void **)&obj->bss;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "uretprobe";
	s->progs[0].prog = &obj->progs.uretprobe;
	s->progs[0].link = &obj->links.uretprobe;

	s->data = uprobe_syscall__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *uprobe_syscall__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xf8\x08\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x09\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x75\x72\
\x65\x74\x70\x72\x6f\x62\x65\x2f\x2f\x70\x72\x6f\x63\x2f\x73\x65\x6c\x66\x2f\
\x65\x78\x65\x3a\x75\x72\x65\x74\x70\x72\x6f\x62\x65\x5f\x72\x65\x67\x73\x5f\
\x74\x72\x69\x67\x67\x65\x72\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x62\x73\x73\0\
\x75\x70\x72\x6f\x62\x65\x5f\x73\x79\x73\x63\x61\x6c\x6c\x2e\x63\0\x75\x72\x65\
\x74\x70\x72\x6f\x62\x65\0\x72\x65\x67\x73\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\
\x2e\x72\x65\x6c\x75\x72\x65\x74\x70\x72\x6f\x62\x65\x2f\x2f\x70\x72\x6f\x63\
\x2f\x73\x65\x6c\x66\x2f\x65\x78\x65\x3a\x75\x72\x65\x74\x70\x72\x6f\x62\x65\
\x5f\x72\x65\x67\x73\x5f\x74\x72\x69\x67\x67\x65\x72\0\x2e\x42\x54\x46\0\x2e\
\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x4e\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x5f\0\0\0\x12\0\x03\0\0\0\0\0\0\0\
\0\0\x70\x01\0\0\0\0\0\0\x69\0\0\0\x11\0\x05\0\0\0\0\0\0\0\0\0\xa8\0\0\0\0\0\0\
\0\x6e\0\0\0\x11\0\x04\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\x79\x13\xa0\0\0\0\0\
\0\x18\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x7b\x32\xa0\0\0\0\0\0\x79\x13\x98\0\0\0\
\0\0\x7b\x32\x98\0\0\0\0\0\x79\x13\x90\0\0\0\0\0\x7b\x32\x90\0\0\0\0\0\x79\x13\
\x88\0\0\0\0\0\x7b\x32\x88\0\0\0\0\0\x79\x13\x80\0\0\0\0\0\x7b\x32\x80\0\0\0\0\
\0\x79\x13\x78\0\0\0\0\0\x7b\x32\x78\0\0\0\0\0\x79\x13\x70\0\0\0\0\0\x7b\x32\
\x70\0\0\0\0\0\x79\x13\x68\0\0\0\0\0\x7b\x32\x68\0\0\0\0\0\x79\x13\x60\0\0\0\0\
\0\x7b\x32\x60\0\0\0\0\0\x79\x13\x58\0\0\0\0\0\x7b\x32\x58\0\0\0\0\0\x79\x13\
\x50\0\0\0\0\0\x7b\x32\x50\0\0\0\0\0\x79\x13\x48\0\0\0\0\0\x7b\x32\x48\0\0\0\0\
\0\x79\x13\x40\0\0\0\0\0\x7b\x32\x40\0\0\0\0\0\x79\x13\x38\0\0\0\0\0\x7b\x32\
\x38\0\0\0\0\0\x79\x13\x30\0\0\0\0\0\x7b\x32\x30\0\0\0\0\0\x79\x13\x28\0\0\0\0\
\0\x7b\x32\x28\0\0\0\0\0\x79\x13\x20\0\0\0\0\0\x7b\x32\x20\0\0\0\0\0\x79\x13\
\x18\0\0\0\0\0\x7b\x32\x18\0\0\0\0\0\x79\x13\x10\0\0\0\0\0\x7b\x32\x10\0\0\0\0\
\0\x79\x13\x08\0\0\0\0\0\x7b\x32\x08\0\0\0\0\0\x79\x11\0\0\0\0\0\0\x7b\x12\0\0\
\0\0\0\0\xb4\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\x47\x50\x4c\0\0\0\0\0\x08\0\0\0\0\
\0\0\0\x01\0\0\0\x04\0\0\0\x9f\xeb\x01\0\x18\0\0\0\0\0\0\0\x40\x03\0\0\x40\x03\
\0\0\x26\x02\0\0\0\0\0\0\0\0\0\x02\x02\0\0\0\x01\0\0\0\x15\0\0\x04\xa8\0\0\0\
\x09\0\0\0\x03\0\0\0\0\0\0\0\x0d\0\0\0\x03\0\0\0\x40\0\0\0\x11\0\0\0\x03\0\0\0\
\x80\0\0\0\x15\0\0\0\x03\0\0\0\xc0\0\0\0\x19\0\0\0\x03\0\0\0\0\x01\0\0\x1c\0\0\
\0\x03\0\0\0\x40\x01\0\0\x1f\0\0\0\x03\0\0\0\x80\x01\0\0\x23\0\0\0\x03\0\0\0\
\xc0\x01\0\0\x27\0\0\0\x03\0\0\0\0\x02\0\0\x2a\0\0\0\x03\0\0\0\x40\x02\0\0\x2d\
\0\0\0\x03\0\0\0\x80\x02\0\0\x30\0\0\0\x03\0\0\0\xc0\x02\0\0\x33\0\0\0\x03\0\0\
\0\0\x03\0\0\x36\0\0\0\x03\0\0\0\x40\x03\0\0\x39\0\0\0\x03\0\0\0\x80\x03\0\0\
\x3c\0\0\0\x03\0\0\0\xc0\x03\0\0\x44\0\0\0\x03\0\0\0\0\x04\0\0\0\0\0\0\x04\0\0\
\0\x40\x04\0\0\x47\0\0\0\x03\0\0\0\x80\x04\0\0\x4d\0\0\0\x03\0\0\0\xc0\x04\0\0\
\0\0\0\0\x0c\0\0\0\0\x05\0\0\x50\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\0\0\0\0\0\
\x03\0\0\x05\x08\0\0\0\x5e\0\0\0\x05\0\0\0\0\0\0\0\x61\0\0\0\x08\0\0\0\0\0\0\0\
\x65\0\0\0\x0b\0\0\0\0\0\0\0\x6d\0\0\0\0\0\0\x08\x06\0\0\0\x71\0\0\0\0\0\0\x08\
\x07\0\0\0\x77\0\0\0\0\0\0\x01\x02\0\0\0\x10\0\0\0\x86\0\0\0\0\0\0\x08\x09\0\0\
\0\x8a\0\0\0\0\0\0\x08\x0a\0\0\0\x90\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\0\x65\0\
\0\0\x03\0\0\x84\x08\0\0\0\x5e\0\0\0\x08\0\0\0\0\0\0\x10\xa3\0\0\0\x08\0\0\0\
\x10\0\0\x02\xa6\0\0\0\x08\0\0\0\x12\0\0\x01\0\0\0\0\x03\0\0\x05\x08\0\0\0\xaa\
\0\0\0\x05\0\0\0\0\0\0\0\xad\0\0\0\x08\0\0\0\0\0\0\0\xb1\0\0\0\x0d\0\0\0\0\0\0\
\0\xb1\0\0\0\x0a\0\0\x84\x08\0\0\0\xaa\0\0\0\x08\0\0\0\0\0\0\x10\xb9\0\0\0\x08\
\0\0\0\x10\0\0\x01\xbd\0\0\0\x08\0\0\0\x11\0\0\x01\xc5\0\0\0\x08\0\0\0\x12\0\0\
\x01\xc9\0\0\0\x08\0\0\0\x20\0\0\x08\xd0\0\0\0\x08\0\0\0\x30\0\0\x04\xd5\0\0\0\
\x08\0\0\0\x38\0\0\x01\xdd\0\0\0\x08\0\0\0\x39\0\0\x01\xe0\0\0\0\x08\0\0\0\x3a\
\0\0\x01\xe7\0\0\0\x08\0\0\0\x3c\0\0\x04\0\0\0\0\x01\0\0\x0d\x0f\0\0\0\xef\0\0\
\0\x01\0\0\0\xf3\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\x01\xf7\0\0\0\x01\0\0\x0c\
\x0e\0\0\0\x01\x01\0\0\0\0\0\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\
\0\x11\0\0\0\x13\0\0\0\x04\0\0\0\x06\x01\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\x1a\
\x01\0\0\0\0\0\x0e\x12\0\0\0\x01\0\0\0\x23\x01\0\0\0\0\0\x0e\x02\0\0\0\x01\0\0\
\0\xe9\x01\0\0\x01\0\0\x0f\x04\0\0\0\x14\0\0\0\0\0\0\0\x04\0\0\0\xf1\x01\0\0\
\x01\0\0\x0f\xa8\0\0\0\x15\0\0\0\0\0\0\0\xa8\0\0\0\0\x70\x74\x5f\x72\x65\x67\
\x73\0\x72\x31\x35\0\x72\x31\x34\0\x72\x31\x33\0\x72\x31\x32\0\x62\x70\0\x62\
\x78\0\x72\x31\x31\0\x72\x31\x30\0\x72\x39\0\x72\x38\0\x61\x78\0\x63\x78\0\x64\
\x78\0\x73\x69\0\x64\x69\0\x6f\x72\x69\x67\x5f\x61\x78\0\x69\x70\0\x66\x6c\x61\
\x67\x73\0\x73\x70\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\x6e\x67\0\x63\
\x73\0\x63\x73\x78\0\x66\x72\x65\x64\x5f\x63\x73\0\x75\x31\x36\0\x5f\x5f\x75\
\x31\x36\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x73\x68\x6f\x72\x74\0\x75\x36\
\x34\0\x5f\x5f\x75\x36\x34\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\x6e\
\x67\x20\x6c\x6f\x6e\x67\0\x73\x6c\0\x77\x66\x65\0\x73\x73\0\x73\x73\x78\0\x66\
\x72\x65\x64\x5f\x73\x73\0\x73\x74\x69\0\x73\x77\x65\x76\x65\x6e\x74\0\x6e\x6d\
\x69\0\x76\x65\x63\x74\x6f\x72\0\x74\x79\x70\x65\0\x65\x6e\x63\x6c\x61\x76\x65\
\0\x6c\x6d\0\x6e\x65\x73\x74\x65\x64\0\x69\x6e\x73\x6e\x6c\x65\x6e\0\x63\x74\
\x78\0\x69\x6e\x74\0\x75\x72\x65\x74\x70\x72\x6f\x62\x65\0\x63\x68\x61\x72\0\
\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\
\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x72\x65\x67\x73\0\x2f\x62\x75\x69\x6c\x64\
\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\x72\
\x6e\x65\x6c\x2d\x36\x2e\x31\x32\x2e\x30\x2d\x35\x35\x2e\x31\x38\x2e\x31\x2e\
\x65\x6c\x31\x30\x5f\x30\x2f\x6c\x69\x6e\x75\x78\x2d\x36\x2e\x31\x32\x2e\x30\
\x2d\x35\x35\x2e\x31\x38\x2e\x31\x2e\x65\x6c\x31\x30\x5f\x30\x2e\x78\x38\x36\
\x5f\x36\x34\x2f\x74\x6f\x6f\x6c\x73\x2f\x74\x65\x73\x74\x69\x6e\x67\x2f\x73\
\x65\x6c\x66\x74\x65\x73\x74\x73\x2f\x62\x70\x66\x2f\x70\x72\x6f\x67\x73\x2f\
\x75\x70\x72\x6f\x62\x65\x5f\x73\x79\x73\x63\x61\x6c\x6c\x2e\x63\0\x09\x5f\x5f\
\x62\x75\x69\x6c\x74\x69\x6e\x5f\x6d\x65\x6d\x63\x70\x79\x28\x26\x72\x65\x67\
\x73\x2c\x20\x63\x74\x78\x2c\x20\x73\x69\x7a\x65\x6f\x66\x28\x72\x65\x67\x73\
\x29\x29\x3b\0\x09\x72\x65\x74\x75\x72\x6e\x20\x30\x3b\0\x6c\x69\x63\x65\x6e\
\x73\x65\0\x2e\x62\x73\x73\0\x75\x72\x65\x74\x70\x72\x6f\x62\x65\x2f\x2f\x70\
\x72\x6f\x63\x2f\x73\x65\x6c\x66\x2f\x65\x78\x65\x3a\x75\x72\x65\x74\x70\x72\
\x6f\x62\x65\x5f\x72\x65\x67\x73\x5f\x74\x72\x69\x67\x67\x65\x72\0\0\0\x9f\xeb\
\x01\0\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\x2c\0\0\0\x40\0\0\0\0\0\0\0\x08\0\
\0\0\xf6\x01\0\0\x01\0\0\0\0\0\0\0\x10\0\0\0\x10\0\0\0\xf6\x01\0\0\x02\0\0\0\0\
\0\0\0\x28\x01\0\0\xb1\x01\0\0\x02\x34\0\0\x60\x01\0\0\x28\x01\0\0\xde\x01\0\0\
\x02\x38\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x03\0\
\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\xb9\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x09\0\0\0\x02\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\x90\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x08\
\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\x11\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x90\x01\0\0\0\0\0\0\x70\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x41\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x03\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\x49\0\0\0\x08\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\x03\0\0\0\0\0\
\0\xa8\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x77\0\0\
\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\x03\0\0\0\0\0\0\x10\0\0\0\0\
\0\0\0\x02\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\xab\0\0\0\x01\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x03\0\0\0\0\0\0\x7e\x05\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb0\0\0\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x98\x08\0\0\0\0\0\0\x60\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct uprobe_syscall *uprobe_syscall::open(const struct bpf_object_open_opts *opts) { return uprobe_syscall__open_opts(opts); }
struct uprobe_syscall *uprobe_syscall::open_and_load() { return uprobe_syscall__open_and_load(); }
int uprobe_syscall::load(struct uprobe_syscall *skel) { return uprobe_syscall__load(skel); }
int uprobe_syscall::attach(struct uprobe_syscall *skel) { return uprobe_syscall__attach(skel); }
void uprobe_syscall::detach(struct uprobe_syscall *skel) { uprobe_syscall__detach(skel); }
void uprobe_syscall::destroy(struct uprobe_syscall *skel) { uprobe_syscall__destroy(skel); }
const void *uprobe_syscall::elf_bytes(size_t *sz) { return uprobe_syscall__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
uprobe_syscall__assert(struct uprobe_syscall *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
	_Static_assert(sizeof(s->bss->regs) == 168, "unexpected size of 'regs'");
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __UPROBE_SYSCALL_SKEL_H__ */
